<?php

namespace Teknisa\MAN\Services;

use Teknisa\MAN\Utilities;

class Setor {

	protected $entityManager;

	public function __construct(\Doctrine\ORM\EntityManager $entityManager)  {
		$this->entityManager = $entityManager;
	}

//Setores
	public function alteraCDSETORSetorFilial($CDSETOR, $NOVOCDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':NOVOCDSETOR' => $NOVOCDSETOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_CDSETOR_SETORFILIAL, $params);
	}

	public function alteraCDSETORSetorProduto($CDSETOR, $NOVOCDSETOR, $CDPRODUTO){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':NOVOCDSETOR' => $NOVOCDSETOR,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_CDSETOR_SETORPRODUTO, $params);
	}

	public function buscaSetores(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_SETORES);
	}

	public function getMaxCDSETOR(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_MAX_CDSETOR);
	}

	public function criaSetor($CDSETOR, $SGSETOR, $NMSETOR, $IDTIPOSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':SGSETOR' => $SGSETOR,
			':NMSETOR' => $NMSETOR,
			':IDTIPOSETOR' => $IDTIPOSETOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_SETOR, $params);
	}
	public function validaSetor($SGSETOR, $NMSETOR, $IDTIPOSETOR, $CDSETOR){
		$params = array(
			':SGSETOR' => $SGSETOR,
			':NMSETOR' => $NMSETOR,
			':IDTIPOSETOR' => $IDTIPOSETOR,
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_SETOR, $params);
	}

	public function alteraSetor($CDSETOR, $NOVOCDSETOR, $SGSETOR, $NMSETOR, $IDTIPOSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':NOVOCDSETOR' => $NOVOCDSETOR,
			':SGSETOR' => $SGSETOR,
			':NMSETOR' => $NMSETOR,
			':IDTIPOSETOR' => $IDTIPOSETOR

		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_SETOR, $params);
	}
	public function excluiSetor($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_SETOR, $params);
	}

	public function excluiSetorLoja($CDSETOR, $CDLOJA){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDLOJA' => $CDLOJA
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_SETOR_LOJA, $params);
	}
	public function excluiProdutosSetor($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_PRODUTOS_SETOR, $params);
	}

	public function buscaSetorFilialPorCDSETOR($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_EXCLUSAO_SETOR, $params);
	}

	public function buscaSetorProdutoPorCDSETOR($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_EXCLUSAO_SETORPRODUTO, $params);
	}
//Produtos
	public function buscaProdutosSetorEspecifico($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PROD_SETOR_ESPECIFICO, $params);
	}
	public function validaProduto( $CDPRODUTO, $CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDPRODUTO' => $CDPRODUTO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_PRODUTO, $params);
	}
	public function criaProdutoSetor($CDSETOR, $CDPRODUTO, $NRTEMPOPROD, $NRTEMPOEXIB){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRTEMPOPROD' => $NRTEMPOPROD,
			':NRTEMPOEXIB' => $NRTEMPOEXIB
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_PRODUTO_SETOR, $params);
	}
	public function alteraProdutoSetor($CDSETOR, $CDPRODUTO, $NRTEMPOPROD, $NRTEMPOEXIB){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRTEMPOPROD' => $NRTEMPOPROD,
			':NRTEMPOEXIB' => $NRTEMPOEXIB
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_PRODUTO_SETOR, $params);
	}

	public function alteraProdutoSetores($CDPRODUTO, $NRTEMPOPROD, $NRTEMPOEXIB){
		$params = array(
			':CDPRODUTO'   => $CDPRODUTO,
			':NRTEMPOPROD' => $NRTEMPOPROD,
			':NRTEMPOEXIB' => $NRTEMPOEXIB
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_PRODUTO_SETORES, $params);
	}

	public function excluiProdutoSetor($CDPRODUTO,$CDSETOR){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_PRODUTO_SETOR, $params);
	}

	//Intervalos

	public function buscaProdutoIntervalo($CDSETOR, $CDPRODUTO, $NRTEMPOINTER = null){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':NRTEMPOINTER' => $NRTEMPOINTER
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_PROD_INTER, $params);
	}

	public function criaProdutoIntervalo($CDSETOR, $CDPRODUTO, $NRSEQINTERVALO, $NRTEMPOINTER){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRSEQINTERVALO' => $NRSEQINTERVALO,
			':NRTEMPOINTER' => $NRTEMPOINTER
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_PRODUTO_INTER, $params);
	}

	public function alteraProdutoIntervalo($CDSETOR, $CDPRODUTO, $NRSEQINTERVALO, $NRTEMPOINTER){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDPRODUTO' => $CDPRODUTO,
			':NRSEQINTERVALO' => $NRSEQINTERVALO,
			':NRTEMPOINTER' => $NRTEMPOINTER
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_PRODUTO_INTER, $params);
	}

	public function excluiProdutoIntervalo($CDPRODUTO,$CDSETOR, $NRSEQINTERVALO){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDSETOR' => $CDSETOR,
			':NRSEQINTERVALO' => $NRSEQINTERVALO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_PRODUTO_INTER, $params);

	}
	
	//Filial

	public function buscaSetorFilial($CDFILIAL){
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_SETOR_FILIAL, $params);
	}

	public function validaProdutoFilial($CDPRODUTO, $CDFILIAL){
		$params = array(
			':CDPRODUTO' => $CDPRODUTO,
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_PRODUTO_FILIAL, $params);
	}

	public function validaSetorFilial($CDSETOR, $CDFILIAL){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDFILIAL' => $CDFILIAL
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_SETORFILIAL, $params);
	}

	public function validaSetorProduto($CDSETOR, $CDFILIAL){
		$params = array(
			':CDSETOR' => $CDSETOR
		);
		$IDTIPOSETOR = $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPO_SETOR, $params);
		$IDTIPOSETOR = $IDTIPOSETOR[0]['IDTIPOSETOR'];

		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDFILIAL' => $CDFILIAL,
			':IDTIPOSETOR' => $IDTIPOSETOR
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_SETORPRODUTO, $params);
	}

	public function criaSetorFilial($CDSETOR, $CDFILIAL, $IDHABSOMKDS, $IDHABROLLBKDS,
									$IDHABTIMERPROD, $IDHABSOMPROD, $IDHABCONTSOMPROD, $IDBLOQPRODKDS,
									$NRROLLBTIME, $IDCONTSOMKDS, $IDHABPREENVIO, $TEMPOBEEP, $NRPRODATRAINISOM, 
									$SOMBEEP, $IDCONCDIRETO){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDFILIAL' => $CDFILIAL,
			':IDHABSOMKDS' => $IDHABSOMKDS,
			':IDHABROLLBKDS' => $IDHABROLLBKDS,
			':IDHABTIMERPROD' => $IDHABTIMERPROD,
			':IDHABSOMPROD' => $IDHABSOMPROD,
			':IDHABCONTSOMPROD' => $IDHABCONTSOMPROD,
			':IDBLOQPRODKDS' => $IDBLOQPRODKDS,
			':NRROLLBTIME' => $NRROLLBTIME,
			':IDCONTSOMKDS' => $IDCONTSOMKDS,
			':IDHABPREENVIO' => $IDHABPREENVIO,
			':TEMPOBEEP' => $TEMPOBEEP,
			':NRPRODATRAINISOM' => $NRPRODATRAINISOM,
			':SOMBEEP' => $SOMBEEP,
			':IDCONCDIRETO' => $IDCONCDIRETO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_SETOR_FILIAL, $params);
	}

	public function alteraSetorFilial($CDSETOR, $CDFILIAL, $IDHABSOMKDS, $IDHABROLLBKDS,
									$IDHABTIMERPROD, $IDHABSOMPROD, $IDHABCONTSOMPROD, $IDBLOQPRODKDS,
									$NRROLLBTIME, $IDCONTSOMKDS, $IDHABPREENVIO, $TEMPOBEEP, $NRPRODATRAINISOM, 
									$SOMBEEP, $IDCONCDIRETO){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDFILIAL' => $CDFILIAL,
			':IDHABSOMKDS' => $IDHABSOMKDS,
			':IDHABROLLBKDS' => $IDHABROLLBKDS,
			':IDHABTIMERPROD' => $IDHABTIMERPROD,
			':IDHABSOMPROD' => $IDHABSOMPROD,
			':IDHABCONTSOMPROD' => $IDHABCONTSOMPROD,
			':IDBLOQPRODKDS' => $IDBLOQPRODKDS,
			':NRROLLBTIME' => $NRROLLBTIME,
			':IDCONTSOMKDS' => $IDCONTSOMKDS,
			':IDHABPREENVIO' => $IDHABPREENVIO,
			':TEMPOBEEP' => $TEMPOBEEP,
			':NRPRODATRAINISOM' => $NRPRODATRAINISOM,
			':SOMBEEP' => $SOMBEEP,
			':IDCONCDIRETO' => $IDCONCDIRETO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_SETOR_FILIAL, $params);
	}

	public function excluiSetorFilial($CDSETOR, $CDFILIAL){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_SETOR_FILIAL, $params);
	}

	public function getAtrasoPadrao($CDFILIAL) {
		$params = array(
			':CDFILIAL' => $CDFILIAL
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_ATRASO_PADRAO, $params);
	}

	public function editAtrasoPadrao($CDFILIAL, $NRATRAPADRAO) {
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':NRATRAPADRAO' => $NRATRAPADRAO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_ATRASO_PADRAO, $params);
	}

//Cores
	public function buscaCoresPedido(){
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_CORES_PEDIDO);
	}

	public function buscaCorPedido($NRSEQCORPEDIDO){
		$params = array(
			':NRSEQCORPEDIDO' => $NRSEQCORPEDIDO
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_COR_PEDIDO, $params);
	}
	public function criaCor($NRINICIOCOR, $NRFINALCOR, $IDPISCAPED, $NRCORPEDIDO, $NRSEQCORPEDIDO){
		$params = array(
			':NRINICIOCOR' => $NRINICIOCOR,
			':NRFINALCOR' => $NRFINALCOR,
			':IDPISCAPED' => $IDPISCAPED,
			':NRCORPEDIDO' => $NRCORPEDIDO,
			':NRSEQCORPEDIDO' => $NRSEQCORPEDIDO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::CRIA_COR, $params);
	}
	public function alteraCor($NRINICIOCOR, $NRFINALCOR, $IDPISCAPED, $NRCORPEDIDO, $NRSEQCORPEDIDO){
		$params = array(
			':NRINICIOCOR' => $NRINICIOCOR,
			':NRFINALCOR' => $NRFINALCOR,
			':IDPISCAPED' => $IDPISCAPED,
			':NRCORPEDIDO' => $NRCORPEDIDO,
			':NRSEQCORPEDIDO' => $NRSEQCORPEDIDO
		);
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::ALTERA_COR, $params);
	}
	public function validaCor($NRINICIOCOR, $NRFINALCOR, $NRSEQCORPEDIDO){
		$params = array(
			':NRINICIOCOR' => $NRINICIOCOR,
			':NRFINALCOR' => $NRFINALCOR,
			':NRSEQCORPEDIDO' => $NRSEQCORPEDIDO
		);

		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::VALIDA_COR, $params);
	}
	public function excluiCor($NRSEQCORPEDIDO){
		$params = array(
			':NRSEQCORPEDIDO' => $NRSEQCORPEDIDO
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::EXCLUI_COR, $params);
	}

	public function buscaTipoSetor($CDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR
		);
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::GET_TIPO_SETOR, $params);
	}

	public function importarProduto($CDSETOR, $ECDSETOR){
		$params = array(
			':CDSETOR' => $CDSETOR,
			':ECDSETOR' => $ECDSETOR
		);    		
		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::IMPORTA_PRODUTO, $params);
	}

	public function buscaSetorFilialEspecifica($ECDFILIAL, $CDSETOR){
		$params = array(
			':CDFILIAL' => $ECDFILIAL,
			':CDSETOR' => $CDSETOR
		);    		
		return $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_SETOR_FILIAL_ESPECIFICA, $params);
	}

	public function buscaTeclas(){
		$teclas = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TECLAS);
		foreach ($teclas as &$currentItem) {
			switch($currentItem['IDFUNCAO']){
				case '1':
					$currentItem['NMFUNCAO'] = 'Cima';
				break;
				case '2':
					$currentItem['NMFUNCAO'] = 'Baixo';
				break;
				case '3':
					$currentItem['NMFUNCAO'] = 'Esquerda';
				break;
				case '4':
					$currentItem['NMFUNCAO'] = 'Direita';
				break;
				case '5':
					$currentItem['NMFUNCAO'] = 'Enter';
				break;
				case '6':
					$currentItem['NMFUNCAO'] = 'Rollback';
				break;
				case '7':
					$currentItem['NMFUNCAO'] = 'Zoom';
				break;
			}
		}
		return $teclas;
	}

	public function buscaTecla($NRKEY){
		$params = array(
			':NRKEY' => $NRKEY
		);
		$tecla = $this->entityManager->getConnection()->fetchAll(Utilities\Query::BUSCA_TECLA, $params);
		switch($tecla[0]['IDFUNCAO']){
			case '1':
				$tecla[0]['NMFUNCAO'] = 'Cima';
			break;
			case '2':
				$tecla[0]['NMFUNCAO'] = 'Baixo';
			break;
			case '3':
				$tecla[0]['NMFUNCAO'] = 'Esquerda';
			break;
			case '4':
				$tecla[0]['NMFUNCAO'] = 'Direita';
			break;
			case '5':
				$tecla[0]['NMFUNCAO'] = 'Enter';
			break;
			case '6':
				$tecla[0]['NMFUNCAO'] = 'Rollback';
			break;
			case '7':
				$tecla[0]['NMFUNCAO'] = 'Zoom';
			break;
		}
		return $tecla;

	}

	public function excluiTecla($NRKEY){
		$params = array(
			':NRKEY' => $NRKEY
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::DELETE_TECLA, $params);
	}

	public function editaTecla($NRKEY, $IDFUNCAO, $IDKEY){
		$params = array(
			':NRKEY' => $NRKEY,
			':IDFUNCAO' => $IDFUNCAO,
			':IDKEY' => $IDKEY
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::UPDATE_TECLA, $params);
	}

	public function adicionaTecla($NRKEY, $IDFUNCAO, $IDKEY){
		$params = array(
			':NRKEY' => $NRKEY,
			':IDFUNCAO' => $IDFUNCAO,
			':IDKEY' => $IDKEY
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_TECLA, $params);
	}

	public function adicionaSetorLoja($CDFILIAL, $CDLOJA, $CDSETOR){
		$params = array(
			':CDFILIAL' => $CDFILIAL,
			':CDLOJA' => $CDLOJA,
			':CDSETOR' => $CDSETOR
		);

		return $this->entityManager->getConnection()->executeQuery(Utilities\Query::INSERT_SETOR_LOJA, $params);
	}

}